import { LRParser } from '@lezer/lr';
import { styleTags, tags } from '@lezer/highlight';
import { indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LRLanguage, LanguageSupport } from '@codemirror/language';

const highlighting = styleTags({
  'Top/Name Special': tags.keyword,
  Name: tags.tagName,
  Error: tags.special(tags.invalid),
  LineComment: tags.lineComment,
  '( )': tags.paren,
  ',': tags.separator
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_specialName = {__proto__:null,"⚠":40};
const parser$1 = LRParser.deserialize({
  version: 14,
  states: "#`OYQPOOOOQO'#C`'#C`OeQPO'#ClOOQO'#C_'#C_QOQPOOOsQPO'#CcOOQO,59W,59WOOQO'#Ce'#CeO!RQPO'#CnO!ZQPO'#CnO!iQPO,58}OOQO'#Cd'#CdOOQO'#Cf'#CfOOQO,59S,59SO!nQPO,59YOOQO-E6f-E6fOOQO1G.i1G.iP!vQPO'#Ch",
  stateData: "#Q~O_OSPOS~OaPOcROdRO~OUTO]`XT`XZ`X~OaPOcZOd[OTbP~OZ]OTbX~OaPOcZOd[OTbX~OT`O~OZ]OTba~OZ]O~O_cac~",
  goto: "!VcPPPdgPPloooPuPPP{P!SRSOVQOTXRUQQWTR^XQXTR_XQROTVTXRYT",
  nodeNames: "⚠ LineComment Tree Top Name ) ( Ch Special Node Error ,",
  maxTerm: 20,
  nodeProps: [
    ["isolate", 1,""],
    ["openedBy", 5,"("],
    ["closedBy", 6,")"]
  ],
  propSources: [highlighting],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "&w~ReOX!dXY#mYZ#mZ]!d]^#m^p!dpq#mqs!dst$utx!dxy%ayz%fz|!d|}%k}!c!d!c!}%p!}#O!d#O#P#T#P;'S!d;'S;=`#g<%lO!d~!kWc~a~Os!dtx!dz|!d}#O!d#O#P#T#P;'S!d;'S;=`#g<%lO!d~#WTst!dxy!dyz!d|}!d#O#P!d~#jP;=`<%l!d~#v__~c~a~OX!dXY#mYZ#mZ]!d]^#m^p!dpq#mqs!dtx!dz|!d}#O!d#O#P#T#P;'S!d;'S;=`#g<%lO!d~$zTP~OY$uZ]$u^;'S$u;'S;=`%Z<%lO$u~%^P;=`<%l$u~%fOU~~%kOT~~%pOZ~~%uWa~Os%ptx%pz|%p}#O%p#O#P&_#P;'S%p;'S;=`&q<%lO%p~&bTst%pxy%pyz%p|}%p#O#P%p~&tP;=`<%l%p",
  tokenizers: [0],
  topRules: {"Tree":[0,2]},
  specialized: [{term: 19, get: (value) => spec_specialName[value] || -1}],
  tokenPrec: 89
});

let props, data, parser;

props = [ indentNodeProp.add({ Ch: delimitedIndent({ closing: ')' }) }),
          foldNodeProp.add({ Ch: foldInside }) ];

data = { commentTokens: { line: '#' },
         closeBrackets: { brackets: '(' } };

parser = parser$1.configure({ props: props });

/// A language provider, including highlighting and indentation
/// information.
const lr = LRLanguage.define({ name: 'lezer-tree',
                               parser: parser,
                               languageData: data });

/// Language support.
function language
() {
  return new LanguageSupport(lr)
}

export { language, lr };
